// DEFINIOWANIE REJESTROW DLA PIC16F628
#nolist

#byte INDF                         =     0x0000
#byte TMR0                         =     0x0001
#byte PCL                          =     0x0002
#byte STATUS                       =     0x0003
#byte FSR                          =     0x0004
#byte PORTA                        =     0x0005
#byte PORTB                        =     0x0006
#byte PCLATH                       =     0x000A
#byte INTCON                       =     0x000B
#byte PIR1                         =     0x000C
#byte TMR1L                        =     0x000E
#byte TMR1H                        =     0x000F
#byte T1CON                        =     0x0010
#byte TMR2                         =     0x0011
#byte T2CON                        =     0x0012
#byte CCPR1L                       =     0x0015
#byte CCPR1H                       =     0x0016
#byte CCP1CON                      =     0x0017
#byte RCSTA                        =     0x0018
#byte TXREG                        =     0x0019
#byte RCREG                        =     0x001A
#byte CMCON                        =     0x001F

#byte OPTION_REG                   =     0x0081
#byte TRISA                        =     0x0085
#byte TRISB                        =     0x0086
#byte PIE1                         =     0x008C
#byte PCON                         =     0x008E
#byte PR2                          =     0x0092
#byte TXSTA                        =     0x0098
#byte SPBRG                        =     0x0099
#byte EEDATA                       =     0x009A
#byte EEADR                        =     0x009B
#byte EECON1                       =     0x009C
#byte EECON2                       =     0x009D
#byte VRCON                        =     0x009F

#bit  porta_0                      =     0x5.0
#bit  porta_1                      =     0x5.1
#bit  porta_2                      =     0x5.2
#bit  porta_3                      =     0x5.3
#bit  porta_4                      =     0x5.4
#bit  porta_5                      =     0x5.5
#bit  porta_6                      =     0x5.6
#bit  porta_7                      =     0x5.7
#bit  trisa_0                      =     0x85.0
#bit  trisa_1                      =     0x85.1
#bit  trisa_2                      =     0x85.2
#bit  trisa_3                      =     0x85.3
#bit  trisa_4                      =     0x85.4
#bit  trisa_5                      =     0x85.5
#bit  trisa_6                      =     0x85.6
#bit  trisa_7                      =     0x85.7

#bit  portb_0                      =     0x6.0
#bit  portb_1                      =     0x6.1
#bit  portb_2                      =     0x6.2
#bit  portb_3                      =     0x6.3
#bit  portb_4                      =     0x6.4
#bit  portb_5                      =     0x6.5
#bit  portb_6                      =     0x6.6
#bit  portb_7                      =     0x6.7
#bit  trisb_0                      =     0x86.0
#bit  trisb_1                      =     0x86.1
#bit  trisb_2                      =     0x86.2
#bit  trisb_3                      =     0x86.3
#bit  trisb_4                      =     0x86.4
#bit  trisb_5                      =     0x86.5
#bit  trisb_6                      =     0x86.6
#bit  trisb_7                      =     0x86.7



//----- STATUS Bits --------------------------------------------------------
//#byte STATUS                         =      0x03
#bit  IRP                     =      0x03.7
#bit  RP1                     =      0x03.6
#bit  RP0                     =      0x03.5
#bit  NOT_TO                  =      0x03.4
#bit  NOT_PD                  =      0x03.3
#bit  Z                       =      0x03.2
#bit  DC                      =      0x03.1
#bit  C                       =      0x03.0

//;----- INTCON Bits --------------------------------------------------------
//#byte  INTCON                        =  0X08B
#BIT  GIE                     =         0X008B.7
#BIT  PEIE                    =         0X008B.6
#BIT  T0IE                    =         0X008B.5
#BIT  INTE                    =         0X008B.4
#BIT  RBIE                    =         0X008B.3
#BIT  T0IF                    =         0X008B.2
#BIT  INTF                    =         0X008B.1
#BIT  RBIF                    =         0X008B.0
//;----- PIR1 Bits ----------------------------------------------------------
//#byte PIR1                         =     0x000C
#BIT  EEIF                      =       0X00C.7
#BIT  CMIF                      =       0X00C.6
#BIT  RCIF                      =       0X00C.5
#BIT  TXIF                      =       0X00C.4
//BIT PUSTY CZYTANY=0
#BIT  CCP1IF                    =       0X00C.2
#BIT  TMR2IF                    =       0X00C.1
#BIT  TMR1IF                    =       0X00C.0

//;----- T1CON Bits ---------------------------------------------------------
//#byte T1CON                        =       0x0010
//BIT 7 I 6 NIEUZYWANY CZYTANY=0
#BIT    T1CKPS1                =       0X0010.5
#BIT    T1CKPS0                =       0X0010.4
#BIT    T1OSCEN                =       0X0010.3
#BIT    NOT_T1SYNC             =       0X0010.2
#BIT    TMR1CS                 =       0X0010.1
#BIT    TMR1ON                 =       0X0010.0

//;----- T2CON Bits ---------------------------------------------------------
//#byte T2CON                        =     0x0012
//BIT 7 NIEUZYWANY
#BIT    TOUTPS3                =     0X0012.6
#BIT    TOUTPS2                =     0X0012.5
#BIT    TOUTPS1                =     0X0012.4
#BIT    TOUTPS0                =     0X0012.3
#BIT    TMR2ON                 =     0X0012.2
#BIT    T2CKPS1                =     0X0012.1
#BIT    T2CKPS0                =     0X0012.0

//;----- CCP1CON Bits ---------------------------------------------------------
//#BYTE  CCP1CON                     =     0X0017
//BIT 7 I 6 NIEUZYWANY
#BIT     CCP1X               =     0X0017.5
#BIT     CCP1Y               =     0X0017.4
#BIT     CCP1M3              =     0X0017.3
#BIT     CCP1M2              =     0X0017.2
#BIT     CCP1M1              =     0X0017.1
#BIT     CCP1M0              =     0X0017.0

//;----- RCSTA Bits ---------------------------------------------------------
//#BYTE  RCSTA                       =    0X0018
#BIT    SPEN                   =    0X0018.7
#BIT    SPENRX9                =    0X0018.6
#BIT    SPENSREN               =    0X0018.5
#BIT    SPENCREN               =    0X0018.4
#BIT    SPENADEN               =    0X0018.3
#BIT    SPENFERR               =    0X0018.2
#BIT    SPENOERR               =    0X0018.1
#BIT    SPENRX9D               =    0X0018.0

//;----- CMCON Bits ---------------------------------------------------------
//#BYTE  CMCON                       =     0X001F
#BIT     C2OUT                 =     0X001F.7
#BIT     C1OUT                 =     0X001F.6
#BIT     C2INV                 =     0X001F.5
#BIT     C1INV                 =     0X001F.4
#BIT     CIS                   =     0X001F.3
#BIT     CM2                   =     0X001F.2
#BIT     CM1                   =     0X001F.1
#BIT     CM0                   =     0X001F.0

//;----- OPTION Bits --------------------------------------------------------
#BYTE    OPTION                        =     0X0081
#BIT     RBPU                   =     0X081.7
#BIT     INTEDG                 =     0X081.6
#BIT     T0CS                   =     0X081.5
#BIT     T0SE                   =     0X081.4
#BIT     PSA                    =     0X081.3
#BIT     PS2                    =     0X081.2
#BIT     PS1                    =     0X081.1
#BIT     PS0                    =     0X081.0

//;----- PIE1 Bits ----------------------------------------------------------
//BYTE   PIE1                          =     0X008C
#BIT     EEIE                     =     0X008C.7
#BIT     CMIE                     =     0X008C.6
#BIT     RCIE                     =     0X008C.5
#BIT     TXIE                     =     0X008C.4
//BIT 3 NIEUZYWANY
#BIT     CCP1IE                   =     0X008C.2
#BIT     TMR2IE                   =     0X008C.1
#BIT     TMR1IE                   =     0X008C.0

//;----- PCON Bits ----------------------------------------------------------
//#BYTE  PCON                          =     0X008E
//BITY 7,6,5,4,NIEUZYWANE
#BIT     OSCF                     =     0X008E.3
#BIT     NOT_POR                  =     0X008E.2
#BIT     NOT_BOR                  =     0X008E.1
#BIT     NOT_BOD                  =     0X008E.0

//;----- TXSTA Bits ----------------------------------------------------------
//#BYTE  TXSTA                      =     0X0098
#BIT     CSRC                 =     0X0098.7
#BIT     TX9                  =     0X0098.6
#BIT     TXEN                 =     0X0098.5
#BIT     SYNC                 =     0X0098.4
//BIT 3 NIEUZYWANY
#BIT     BRGH                 =     0X0098.2
#BIT     TRMT                 =     0X0098.1
#BIT     TX9D                 =     0X0098.0

//;----- EECON1 Bits ---------------------------------------------------------
//#BYTE  EECON1                     =     0X009C
//BITY 7,6,5,4, NIEUZYWANE
#BIT     WRERR               =     0X009C.3
#BIT     WREN                =     0X009C.2
#BIT     WR                  =     0X009C.1
#BIT     RD                  =     0X009C.0

//;----- VRCON Bits ---------------------------------------------------------
//#BYTE  VRCON                      =       0X009F
#BIT     VREN                 =     0X009F.7
#BIT     VROE                 =     0X009F.6
#BIT     VRR                  =     0X009F.5
// BIT 4 NIEUZYWANY
#BIT     VR3                  =     0X009F.3
#BIT     VR2                  =     0X009F.2
#BIT     VR1                  =     0X009F.1
#BIT     VR0                  =     0X009F.0


/*
//;==========================================================================
;
;       RAM Definition
;
;==========================================================================

    __MAXRAM H'01FF'
    __BADRAM H'07'-H'09', H'0D', H'13'-H'14', H'1B'-H'1E'
    __BADRAM H'87'-H'89', H'8D', H'8F'-H'91', H'93'-H'97', H'9E'
    __BADRAM H'105', H'107'-H'109', H'10C'-H'11F', H'150'-H'16F'
    __BADRAM H'185', H'187'-H'189', H'18C'-H'1EF'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_BODEN_ON                    EQU     H'3FFF'
_BODEN_OFF                   EQU     H'3FBF'
_CP_ALL                      EQU     H'03FF'
_CP_75                       EQU     H'17FF'
_CP_50                       EQU     H'2BFF'
_CP_OFF                      EQU     H'3FFF'
_DATA_CP_ON                  EQU     H'3EFF'
_DATA_CP_OFF                 EQU     H'3FFF'
_PWRTE_OFF                   EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LVP_ON                      EQU     H'3FFF'
_LVP_OFF                     EQU     H'3F7F'
_MCLRE_ON                    EQU     H'3FFF'
_MCLRE_OFF                   EQU     H'3FDF'
_ER_OSC_CLKOUT               EQU     H'3FFF'
_ER_OSC_NOCLKOUT             EQU     H'3FFE'
_INTRC_OSC_CLKOUT            EQU     H'3FFD'
_INTRC_OSC_NOCLKOUT          EQU     H'3FFC'
_EXTCLK_OSC                  EQU     H'3FEF'
_LP_OSC                      EQU     H'3FEC'
_XT_OSC                      EQU     H'3FED'
_HS_OSC                      EQU     H'3FEE'

        LIST
*/
#list
