//////////////////////////////////////////////////////////////////////////
////                        Dallas Touch Driver                       ////
////                                                                  ////
////  present = touch_present()   Issues a reset and returns TRUE     ////
////                              if the touch device is there.       ////
////                                                                  ////
////  data = touch_read_byte()    Reads one byte from a touch device. ////
////                                                                  ////
////  ok = touch_write_byte(data) Writes one byte to a touch device   ////
////                              and returns TRUE if all went OK.    ////
////                              A FALSE indicates a collision with  ////
////                              another device.                     ////
////                                                                  ////
//////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////
/// Krzysztof Pawsiuk 22.05.2003- wprowadzone modyfikacje zwiekszajace ////
/// maksymalna odleglosc ukladu od procesora, dodana druga procedura    ////
/// do utworzenia drugiej magistrali 1Wire								////
////////////////////////////////////////////////////////////////////////////


//*************************************************************************//
#define TOUCH_PIN  PIN_b0				//definicja wyprowadzenia 1Wire
#bit    TOUCH_PIN_BIT = 6.0

//odczyt jednego bajtu, odczytany bajt jest zwracany jako parametr
byte touch_read_byte()
{byte i,data;
 for(i=1;i<=8;++i)
    {
     output_low(TOUCH_PIN);
     delay_us(14);
     output_float(TOUCH_PIN);
     delay_us(5);
     shift_right(&data,1,input(TOUCH_PIN));
     delay_us(100);
    }
   return(data);
}
//zapis jednego bajtu, podany jako parametr
byte touch_write_byte(byte data)
{byte i;
 for(i=1;i<=8;++i)
 	{
     output_low(TOUCH_PIN);
     delay_us(10);
     if(shift_right(&data,1,0))
     	{output_high(TOUCH_PIN);}
     else {
       output_low(TOUCH_PIN);}
     delay_us(50);
     output_high(TOUCH_PIN);
     delay_us(50);
    }
   return(TRUE);
}

//generuje reset magistrali i zwraca 1 jesli uklad sie zglosi
byte touch_present()
{boolean present;
 output_low(TOUCH_PIN);
 delay_us(500);
 output_float(TOUCH_PIN);
 if(!input(TOUCH_PIN))
   	return(FALSE);
 delay_us(65);
 present=!input(TOUCH_PIN);
 delay_us(240);
 if(present)
      return(TRUE);
 else
      return(FALSE);
}
//****************************************************************************//
//procedury do komunikcji 1wire na drugim pinie

#ifndef TOUCH_PIN1

#define TOUCH_PIN1  PIN_b1				//definicja wyprowadzenie 1Wire
#bit    TOUCH_PIN_BIT1 = 6.1			//dla drugiego czujnika

#endif


byte touch1_read_byte() {
   byte i,data;

   for(i=1;i<=8;++i) {
     output_low(TOUCH_PIN1);
     delay_us(14);
     output_float(TOUCH_PIN1);
     delay_us(5);
     shift_right(&data,1,input(TOUCH_PIN1));
     delay_us(100);
    }
   return(data);
}

byte touch1_write_byte(byte data) {
   byte i;

   for(i=1;i<=8;++i) {
     output_low(TOUCH_PIN1);
     delay_us(10);
     if(shift_right(&data,1,0))
     	{
          output_high(TOUCH_PIN1);
     	}
     else {
       		output_low(TOUCH_PIN1);
     	  }
     delay_us(50);
     output_high(TOUCH_PIN1);
     delay_us(50);
   }
   return(TRUE);
}

byte touch1_present() {
    boolean present;

    output_low(TOUCH_PIN1);
    delay_us(500);
    output_float(TOUCH_PIN1);
    if(!input(TOUCH_PIN1))
      return(FALSE);
    delay_us(65);
    present=!input(TOUCH_PIN1);
    delay_us(240);
    if(present)
      return(TRUE);
    else
      return(FALSE);
}

