
////////////////////////////////////////////////////////////////////////////
//  Name    : SAA1064.c                                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2003-03-12                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////

#define SAA1064_adres_wr 	0b01110000		//adres zapisu danych, jesli A0=0, A1=0
#define SAA1064_adres_re 	0b01110001		//adres odczytu danych jesli A0=0, A1=0
#define digit2_3m			0b00010110		//2 wyswietlacze I=3mA
#define digit2_6m			0b00100110		//2 wyswietlacze I=6mA
#define digit2_12m			0b01000110		//2 wyswietlacze I=12mA
#define digit4_3m			0b00010111		//4 wyswietlacze I=3mA
#define digit4_6m			0b00100111		//4 wyswietlacze I=6mA
#define digit4_12m			0b01000111		//4 wyswietlacze I=12mA


//************************************************************************//
//  zapisuje konfiguracje  do SAA1064                                     //
//************************************************************************//
SAA1064_write_control(int control)
{
	i2c_start();					//start transmisji I2C
	i2c_write(SAA1064_adres_wr);	//zapis adresu ukadu SAA1064
	i2c_write(0);					//podanie sub-adresu = 0, bo to zapis konfiguracji
	i2c_write(control);				//zapis wartoci do rejestru konfiguracyjnego
	i2c_stop();						//koniec transmisji I2C
}
//************************************************************************//
//************************************************************************//
// zapisuje dane na wyswietlaczu o numerze podanym w numer	              //
//************************************************************************//
SAA1064_write_digit(int numer, int dig)
{int i;
	i2c_start();					//start transmisji I2C
	i2c_write(SAA1064_adres_wr);	//zapis adresu ukadu SAA1064
	i2c_write(numer);				//zapis numery cyfry, ktrej dotyczy wpis
	i2c_write(dig);					//zapis wartoci do rejestru podanego wczesniej
	i2c_stop();						//koniec transmisji I2C
}
//************************************************************************//