
////////////////////////////////////////////////////////////////////////////
//  Name    : Miernik_pojemnosci.c                                     	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2003 	                                      //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-03-20                                                  //
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
#include <12f629.h>
#include <f629.h>
//#fuses XT,NOWDT,NOPROTECT			//LP,XT,HS,RC,WDT->NOWDT
// 	BG1	BG0	 NC   NC  NC  CPD  CP BODEN MCLR PWRTE WDTE FOSC2 FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5    4     3     2   1      0
//   1	 1    0	   0   0   1   1    1    0    0     0     0   1      0
//  BG-HVolt             OFF  OFF   ON  PIN  ON    OFF   EXT HS

#rom 0x2007={0b11000111000010}
#use delay(clock=20000000)
#use i2c(master,scl=pin_a0,sda=pin_a1)		//definicja I2C
#id 0,3,0,3

#include <saa1064.h>						//obsluga SAA1064
#bit tmr1i= 0xc.0
#define enable gpio_2
#define enable_tris trisio_2
#define tin gpio_3							//wejscie sygnalu z icl555

int16 c_high,c_low;
int32 c_var;
int16 min;
int digit[5];
int dig_i;
#define dig0 digit[0]
#define dig1 digit[1]
#define dig2 digit[2]
#define dig3 digit[3]
#define dig4 digit[4]
//definicja wyswietlanych cyfr
byte const cyfry[14]={0b00111111,0b00000110,0b01011011,0b01001111,0b01100110,
					 0b01101101,0b01111101,0b00000111,0b01111111,0b01101111,
					 0b01110011,0b01010100,0b00011100,0xb00000000};

get_c();									//mierzy pojemnosc

main()
{
boolean nano;
int i;
gpio=0b01000000;
trisio=0b00001000;
wpu=0b11111111;								//wlacza podciaganie enable
bit_clear(option_reg,7);					//wlacza podciaganie globalne
cmcon=7;
enable=1;
output_float(pin_a0);
output_float(pin_a1);
enable_tris=0;

//setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);   // setup interrupts
t1con=0b00000101;							//tmr1 z wewnetrznego kwarcu, presk=1
saa1064_write_control(digit4_6m);			//konfiguracja saa1064 4cyfry prad=6ma



while(1) 								//GLOWNA PETLA
	{
	get_c();
	delay_ms(100);

	}

}
///////////////////////////////////////////////////////////////////////////

//***************************************************************************//
//  zamienia wejsciowa liczbe binarna int16, na dziesietna i umieszcza
//  wkolejne cyfry w buforze, cyfry dostepne sa jako dig0,dig1 ...
//  ulatwia to zarzadzanie cyframi , np. rozdzielenie przecinkiem
//**************************************************************************//
void dec_putc(byte w)
{digit[dig_i]=w;
	dig_i--;
if(digit[2]==' ') digit[2]=13;				//jesli spacja to wygasza wyswietlacz 2
if(digit[1]==' ') digit[1]=13;				//jesli spacja to wygasza wyswietlacz 1
	}
//--------------------------------------------------------------
get_dig(int32 zz)
{dig_i=4;
printf(dec_putc,"%5lu",zz);}
//**************************************************************************//


//************************************************************************//
// Procedura pomiaru i wyswietlania pojemnosc 							  //	                                                      //
//************************************************************************//
get_c()
{int i;

	bit_clear(t1con,0);			   			//zatrzymaj licznik tmr1
	tmr1l=0;					   			//wyzeruj
	tmr1h=0;
	c_high=0;
	enable=0;					   			//wyzwolenie 555
	enable=1;
	bit_set(t1con,0);			   			//wlacz tmr1
	while(tin)				  	   			//dopoki na wejsciu tin stan wysoki to licz impulsy
		{
		if(tmr1i)				   			//jesli przepelnienie tmr1, to zwieksz c_high
			{tmr1i=0;
			c_high++;
			}
		}
	bit_clear(t1con,0);			   			//zatrzymaj tmr1
	c_low=make16(tmr1h,tmr1l);
	c_var=make32(c_high,c_low);
	c_var/=5;
	if(c_var<18) c_var=0;					//nalezy odjac 18, aby bez pojemnosci wynik byl =0
	else c_var-=18;							//jesli bez pojemnosci wynik jest mniejszy od 18, to wpisz 0
	if(c_var>999999)						//jesli 1000000 lub wiecej to w uF
		{c_var/=10000;						//podziel 10000, zeby byly tylko 3znaczace cyfry
		get_dig(c_var);						//przeksztalc na 3cyfry dziesietne
		i=cyfry[dig2&0x0f];
		bit_set(i,7);						//zapala kropke na 1 wyswietlaczu
		SAA1064_write_digit(1,i);
		SAA1064_write_digit(3,cyfry[dig1&0x0f]);
		SAA1064_write_digit(2,cyfry[dig0&0x0f]);
		SAA1064_write_digit(4,cyfry[12]);	// u
			}

	else if(c_var>99999)					//jesli 100000 lub woecej to zakres nF-max 999nF
			{c_var/=1000;					//podziel aby wynik byl 3cyfrowy
			get_dig(c_var);
			SAA1064_write_digit(1,cyfry[dig2&0x0f]);
			SAA1064_write_digit(3,cyfry[dig1&0x0f]);
			SAA1064_write_digit(2,cyfry[dig0&0x0f]);
			SAA1064_write_digit(4,cyfry[11]);	// n
			}
	else if(c_var>9999)						//jesli wynik 10000 lub wiecej to zakres nF - max 99,9nF
			{c_var/=100;					//podziel aby wynik byl 3cyfrowy
			get_dig(c_var);
			SAA1064_write_digit(1,cyfry[dig2&0x0f]);
			i=cyfry[dig1&0x0f];
			bit_set(i,7);					//zapala kropke na 2 wyswietlaczu
			SAA1064_write_digit(3,i);
			SAA1064_write_digit(2,cyfry[dig0&0x0f]);
			SAA1064_write_digit(4,cyfry[11]);	// n
			}
	else if(c_var>999)						//jesli wynik 1000 lub wiecej to zakres nF max 9,99nF
			{c_var/=10;						//podziel aby wynik byl 3cyfrowy
			get_dig(c_var);
			i=cyfry[dig2&0x0f];
			bit_set(i,7);					//zapala kropke na 1 wyswietlaczu
			SAA1064_write_digit(1,i);
			SAA1064_write_digit(3,cyfry[dig1&0x0f]); //format x.xxnF
			SAA1064_write_digit(2,cyfry[dig0&0x0f]);
			SAA1064_write_digit(4,cyfry[11]);	// n
			}
   else 									//jesli wynik mniejszy niz 1000, to zakres pF- max 999pF
		{
			get_dig(c_var);
			SAA1064_write_digit(1,cyfry[dig2&0x0f]);
			SAA1064_write_digit(3,cyfry[dig1&0x0f]);
			SAA1064_write_digit(2,cyfry[dig0&0x0f]);
			SAA1064_write_digit(4,cyfry[10]);	// p
			}
}
//************************************************************************//