
////////////////////////////////////////////////////////////////////////////
//  Name    : Multimetr mowiacy.c                                    	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 		                                  //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-09-13 				                                  //
//  Version : 1.0   				                                      //
//  Notes   :                                                             //
//          :                                                             //
////////////////////////////////////////////////////////////////////////////
#include <16f872.h>
#include <f872.h>
// 			DEBUG     WRT CPD LVP BODEN CP1 CP0 PWRTE WDTE FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5   4    3     2   1      0
#rom 0x2007={0b00100100111011}		//bezpieczniki
#use delay(clock=4000000)			//
#id 0,9,0,2

//---------------------definiowanie polaczen i zmiennych-------------------//

#define D1	pin_a0					//kod wyswietlacza nr1
#define D2	pin_a1					//kod wyswietlacza nr2
#define D3	pin_a2					//kod wyswietlacza nr3
#define D4	pin_a3					//kod wyswietlacza nr4
#define D5	pin_a4					//kod wyswietlacza nr5
#define pol	pin_a5					//wejscie sygnalu polaryzacji napiecia
#define data	portc				//port wejsciowy wartosci pomiaru
#define busy	pin_c5				//portc_5
#define overrange pin_c4			//wejscie sygnalizujace przekroczenie zakresu pomiarowego
boolean	minus;						//znak minus, jesli ujemna to=1
boolean over;						//znacznik ze zostal przekroczony zakres pomiarowy
int cyfra[5];						//bufor cyfr podawanych przez icl
int time;							//komorka do odliczania czasu
int time_buf;						//zapisany jest czas pomiedzy kolejnymi pomiarami
int zakres;							//zakresu pomiarowego
int zakres_buf;						//bufor zakresu pomiarowego
#define JP2 portb_5
#define JP1	portb_6
#define JP3	portc_7
#define JP4	portc_6

#define timer1_set	0xffff-62500	//przerwanie co 500ms, presk./8
#include <isd2560.h>				//wczytaj obsluge isd2560


//*******************TABLICA KOMUNIKATOW ZAWARTYCH W ISD2560******************//
//0->19 kolejne cyfry 20komunikatow

#define dwadziescia							21
#define	trzydziesci							22
#define czterdziesci						23
#define	piecdziesiat						24
#define szescdziesiat						25
#define siedemdziesiat						26
#define osiemdziesiat						27
#define dziewiecdziesiat					28
#define sto									29
#define dwiescie							30
#define trzysta								31
#define czterysta							32
#define piecset								33
#define szescset							34
#define siedemset							35
#define osiemset							36
#define dziewiecset							37
#define tysiac								38
#define dwa_tysiace							39
#define wolt								40
#define wolty								41
#define _i									42
#define miliwolt							43
#define miliwolty							44
#define minus_								45
#define _zakres								46
#define zakres_przekroczony					47
#define komunikaty							47
#rom 0x2100={2}							//poczatkowy czas miedzy pomiarami 1s.
//tablica pozwala na odpowiednie wypowiadanie dziesiatek
byte const dziesiatki[10]={0,0,dwadziescia,trzydziesci,czterdziesci,piecdziesiat,szescdziesiat,siedemdziesiat,osiemdziesiat,dziewiecdziesiat};
//tablica pozwala na prawidlowe wymawianie setek
byte const setki[10]={0,sto,dwiescie,trzysta,czterysta,piecset,szescset,siedemset,osiemset,dziewiecset};
////tablica pozwala na odpowiednia odmiane "miliwolt" dla napiec >19mV
byte const mwolt[10]={miliwolt,miliwolt,miliwolty,miliwolty,miliwolty,miliwolt,miliwolt,miliwolt,miliwolt,miliwolt};
////tablica pozwala na odpowiednia odmiane "wolt" dla napiec >19V
byte const wwolt[10]={wolt,wolt,wolty,wolty,wolty,wolt,wolt,wolt,wolt,wolt};

get_napiecie();						//procedura odczytujaca napiecie z ukladu icl
nagraj_komunikaty();				//procedura nagrywa komunikaty w isd
odtworz_komunikaty();				//procedura odtwarza nagrane komunikaty
play_u(int min,int c40,int c30,int c20,int c10,int c01,int c02,int c03);//procedura wypowiada zmierzone napiecie
czas_pomiaru();						//ustala co jaki czas bedzie wykonywany pomiar



//************************************************************************//
//     PETLA GLOWNA PROGRAMU                                              //
//************************************************************************//
main()
{
	byte i,u_buf[5],pauza,ii;
	boolean u_ok;
	ADCON1=0b00000110;                    		//PORTA JAKO CYFROWY
	porta=0;
	trisa=0xff;									//porta jako wejsciowy
	portb=0;
	pd=1;										//wylacza isd
	trisb=0b01100011;							//konfigoracja portu b
	port_b_pullups(true);						//wlacz podciaganie pull-up
	portc=0;
	trisc=0xff;									//portc jako wejscia
	time_buf=read_eeprom(0); 					//przepisz z eeprom czas kolejnego pomiaru
//----------------Ustawia i wlacza timer1 do odliczania czasu------------------------------
	t1con=0b00110001;							//timer1 z wewnetrznego kwarcu,preskaler/8
	set_timer1(timer1_set);						//ustawienie wartosci poczatkowej timera t1
	enable_interrupts(int_timer1);
	enable_interrupts(global);					//wlacza przerwanie globalne
//---------------------------------------------------------
	delay_ms(1000);
	if(!jp1&&!jp2)	czas_pomiaru();				//idzie do zmiany czasu miedzy pomiarami
	if((!jp1)&&(!jp3)) nagraj_komunikaty();		//jesli zwarty jp1 i jp3 to nagrywanie komunikatow
	if((!jp1)&&(!jp4)) odtworz_komunikaty();	//jesli jp1 i jp4 zwarty to odtworz komunikaty

	zakres_buf=0xff;							//ten wpis powoduje, ze przy uruchomieniu podawany jest zakres
	pauza=0;									//zeruje licznik odliczania takich samych wartosci napiecia
	goto czas;									//przy uruchomieniu idz do oczekiwania na pomiar, i powoduje przy starcie
												//powiedzenie zakresu pomiarowego
while(1)
	{
//-----PROCEDURA W ZALEZNOSCI OD ZAKRESU ODPOWIEDNIO FORMATUJE CYFRY DO WYPOWIEDZENIA------//
	if(over)										//jesli przekroczony zakres pomiarowy
		{
		 isd25xx_play(zakres_przekroczony,wait);}	//powiedz zakres przekroczony
	else{											//w przeciwnym przypadku
		switch(zakres_buf)
			{
		case 0:		//-----napiecie dla zakresu	1,999v, jesli jp3=0,jp4=0
			play_u(minus,0,0,0,cyfra[4],cyfra[3],cyfra[2],cyfra[1]);
			break;
		case 1:		//-----napiecie dla zakresu 19,999v
			play_u(minus,0,0,cyfra[4],cyfra[3],cyfra[2],cyfra[1],cyfra[0]);
     		break;
		case 2:		//-----napiecie dla zakresu 199,99v
			play_u(minus,0,cyfra[4],cyfra[3],cyfra[2],cyfra[1],cyfra[0],0);
			break;
		case 3: 	//-----napiecie dla zakresu 1999,9v zakres ten zostal ograniczony, prze co
			    play_u(minus,cyfra[4],cyfra[3],cyfra[2],cyfra[1],cyfra[0],0,0);
			break;
			}
		}
//-------------------KONIEC PROCEDURY FORMATOWANIA CYFR------------------------------//

//-------------------czekaj na kolejne wyzwolenie pomiaru
czas:

		time=0;										//zeruje licznik odlicania czasu do kolejnego pomiaru

//----procedura oczekuje na odliczenie czasu do kolejnego pomiaru, czas jest zwiekszany
//przez TMR1 co 0,5s, dodatkowo podczs oczekiwania sprawdzane jest, czy nie zostal
//zmieniony zakres pomiarowy, jesli tak, to odrazu zostaje wypowiedziany nowy zakres
		while(time<time_buf)						//licznik ten jest zwiekszany w przerwaniu od TMR1
			{
			zakres=0;
			 if(jp3) zakres+=1;						//odczytaj wybrany zakres pomiarowy
			 if(jp4) zakres+=2;						//zalezny od JP3,JP4 i zapisz do zakres
			 if(zakres_buf!=zakres)					//jesli w czasie pracy zmieniono zakres pomiarowy
				{ zakres_buf=zakres;				//to przepisz nowy zakres do bufora
			 	isd25xx_play(_zakres,wait);			//i powiedz zakres
			 	switch(zakres_buf)					//a nastepnie powiedz jaki to zakres
			 		{
						case 0: isd25xx_play(3,wait);			//dwa wolty
								isd25xx_play(wolty,wait);break;
						case 1: isd25xx_play(dwadziescia,wait);	//dwadziescia wolt
								isd25xx_play(wolt,wait);break;
						case 2:isd25xx_play(dwiescie,wait);		//dwiescie wolt
								isd25xx_play(wolt,wait);break;
						case 3: isd25xx_play(dwa_tysiace,wait);	//tysiac wolt
								isd25xx_play(wolt,wait);break;
					}
				}
			}

//-----------------------Koniec oczekiwania na nowy pomiar-------------------------------------

//-------Procedura powoduje wyzwolenie pomiaru, jesli wynik pomiaru jest 5krotnie
//taki sam i JP1=0,to wypowiadanie napiecia jest zatrzymane, po zmianie natychmiast
//nowe napiecie zostaje wypowiedziane, w czasie braku wypowiadania napiecia
// caly czas jest sprawdzane czy nie zmieniono zakresu, aby zareagowac
		get_napiecie();						//zmierz napiecie

		u_ok=0;								//sprawdz czy napiecie w buforze=zmierzonemu
		ii=0;								//podaje od ktorej cyfry ma byc porownywany wynik napiecia
		if(zakres==0) ii=1;					//jesli zakres=2v, to porownuje tylko 4cyfry,
											//gdyz dla tego zakresu najmniej zanaczaca cyfra jest
											//pomijana

		for(i=ii;i<=4;++i)					//porownuje wynik napiecia zmierzonego z zapisanym w buforze
			{if(cyfra[i]!=u_buf[i]) u_ok=1;}// jesli nowe napiecie jest rozne od tego w buforze to u_ok=1

		if(!u_ok)							//jesli nowe napiecie= napieciu w buforze
			{++pauza;						//to zwieksz licznik jednakowego napiecia
			if(pauza>5) pauza=5;}			//jesli zmiezone napiecie takie same > niz 5 razy to wpisz 5
		else
			{pauza=0;						//jesli sie nie rowna to zeruj licznik takiego samego napiecia
			for(i=0;i<=4;++i)				//i przepisz nowa wartosc napiecia do bufora
				u_buf[i]=cyfra[i];}
		if(!jp2&&pauza>4) goto czas;		//jesli 5 razy takie samo napiecie i jp1 zwarty
											//to nie mow napiecia tylko czekaj na jego zmiane
											//w przeciwnym przypadku nastepuje przejscie do wypow. napiecia
	}

}
//******************************KONIEC PETLI GLOWNEJ MAIN*******************************//



/*****************************************************************************************/
/*	                    Obsluga przerwania od T1, nastepuje co 0,5s 					 */
/*****************************************************************************************/

#int_timer1
void timer1_int()
{
	bit_clear(pir1,tmr1if);						  //zeruj flage przerwania od t1
	set_timer1(timer1_set);						  //wpisz poczatkowy stan timer1
	if(++time>120) time=120;					  //liczy tylko do 60sekund

}
//**************************KONIEC OBSLUGI PRZERWANIA OD TMR1*****************************/


//************************************************************************//
//     zmienia czas pomiedzy kolejnymi pomiarami                          //
//************************************************************************//
czas_pomiaru()
{

	while(jp4);							//czekaj na nacisniecie jp4
	delay_ms(100);
	time=0;								//zeruj czas
	while(!jp4);						//czekaj na zwolnienie ip4
	time_buf=time;						//przepisz zmiezony czas do bufora
	delay_ms(10);						//time jest zwiekszany w przerwanu co 0,5s
	write_eeprom(0,time_buf);
	sleep();
}
//************************************************************************//


//************************************************************************//
//odtwarza zmierzone napiecie w zakresie 0-1999,999V
//w formacie uuu wolt,uuu miliwolt
//jesli wartosc liczbowa =0, to procedura isd25xx, mowi zero
//   format napiecia
//	1	 9     9   9    ,   9     9   9
//	c40	c30   c20 c10 wolt  c01  c02 c03  miliwolt
//************************************************************************//
play_u(int min,int c40,int C30,int C20,int C10,int C01,int C02,int C03)
{

// jesli podane napiecie jest rowne zero
if((c01==0)&&(c02==0)&&(c03==0)&&(c10==0)&&(c20==0)&&(c30==0)&&(c40==0))
	{isd25xx_play(1,wait);				//jesli u=0, to powiedz zero wolt
	isd25xx_play(wolt,wait);
	return;}
if(min) isd25xx_play(minus_,wait);		//jesli napiecie ujemne powiedz minus
//--jesli napiecie przed przecinkiem jest wieksze od 0
//i jesli zakres =1999,9V, to jesli>1000 to mowi tysiac

if((c10!=0)||(c20!=0)||(c30!=0)||(c40!=0))		//jesli napiecie przed przecinkiem>0
{
if(c40>0) isd25xx_play(tysiac,wait);
//******************** ODTWARZA CYFRY PRZED PRZECINKIEM  ************************
//jesli napiecie <20V, to przeksztalc tak, ze cala wartosc znajdzie sie
//w c02, pozwoli to na poprawne odtworzenie cyfr z zakresu 0-19
	if(c20==1) c10+=c20*10;
//------------------------------------------------------------------------//
//----odtwarza setki jesli sa>0,jesli =0, ta nastapi skok do procedury
// isd25xx_play i natycmiastowy powrot, gdyz proced. ta nie odtwarza 0;
// wartosci liczbowe odpowiadajace numerom setek pobierane sa z tablicy setki
	isd25xx_play(setki[c30],wait);					//odtwarza setki po przecinku jesli nie sa zerem
//----------------------------------------------------------------------------
//----odtwaza dziesiatki jesli sa>=2, dla mniejszych warosci nic nie jest odtwarzane
//gdyz wartosci liczb. pobierane sa z tablicy dziesiatki, i dla wartosci 0 i 1 zwracane jest 0
	isd25xx_play(dziesiatki[c20],wait);			//odtwaza dziesiatki przed przecinkiem jesli sa>19
//--------------------------------------------------------------------------
//------odtwarza jednosci cyfr z zakresu 0-19
//jesli jednosci sa zerem,
	if(c10>0) isd25xx_play(c10+1,wait);

	if(c20==1)
			isd25xx_play(wolt,wait);
	else
			isd25xx_play(wwolt[c10],wait);

	if((c01!=0)||(c02!=0)||(c03!=0))				//jesli napiecie po przecinku>0
			  isd25xx_play(_i,wait);				//to powiedz jeszcze i
}
//------------------------KONIEC ODTWARZANIA CYFR PRZED PRZECINKIEM---------

//Nastepnie odczytaj wartosci po przecinku
if((c01!=0)||(c02!=0)||(c03!=0))		//jesli napiecie po przecinku>0
{

//********************  ODTWARZA CYFRY PO PRZECINKU  ************************
//jesli napiecie <20mV, to przeksztalc tak ze, cala wartosc znajdzie sie
//w c02, pozwoli to na poprawne odtworzenie cyfr z zakresu 0-19
	if(c02==1) c03+=c02*10;
//------------------------------------------------------------------------//
//----odtwarza setki jesli sa>0,jesli =0, ta nastapi skok do procedury
// isd25xx_play i natycmiastowy powrot, gdyz proced. ta nie odtwarza 0;
// wartosci liczbowe odpowiadajace numerom setek pobierane sa z tablicy setki
	isd25xx_play(setki[c01],wait);					//odtwarza setki po przecinku jesli nie sa zerem
//----------------------------------------------------------------------------
//----odtwaza dziesiatki jesli sa>=2, dla mniejszych warosci nic nie jest odtwarzane
//gdyz wartosci liczb. pobierane sa z tablicy dziesiatki, i dla wartosci 0 i 1 zwracane jest 0
	isd25xx_play(dziesiatki[c02],wait);			//odtwarza dziesiatki po przecinku jesli sa>19
//--------------------------------------------------------------------------
//------odtwarza jednosci cyfr z zakresu 0-19
//jesli jednosci sa zerem,
	//if((cyfra[1]!=0)&&(cyfra[2]>0)) cyfra[1]++;
	if(c03>0) isd25xx_play(c03+1,wait);					//jesli

	if(c02==1)											//odmien miliwolty
			isd25xx_play(miliwolt,wait);
	else
			isd25xx_play(mwolt[c03],wait);
}


}
//*****************KONIEC ODTWARZANIA NAPIECIA****************************//



//************************************************************************//
//     procedura nagrywa komunikaty w ukladzie isd                        //
//************************************************************************//
nagraj_komunikaty()
{
	while(jp4);								//czekaj na zwarcie zworki jp4
	delay_ms(10);
	isd25xx_rec_start();					//rozpocznij nagrywanie
	while(!jp4);							//czekaj na zwolnienie zworki
	isd25xx_rec_pause();					//zatrzymaj nagrywanie
	delay_ms(100);
	while(1)
		{
		if(!jp4)							//jesli jp4 zwarte, to rozpocznij
		   {delay_ms(50);					//zapis kolejnego komunikatu
			isd25xx_rec_next();
			while(!jp4);					//czekaj na zwolnienie JP4
			isd25xx_rec_pause();			//zatrzymaj zapis
			delay_ms(100);
			}
		}
	sleep();
}
//************************************************************************//

//************************************************************************//
// Procedura odtwarzania nagranych komunikatow                            //
//************************************************************************//
odtworz_komunikaty()
{int i=1;
while(!jp4);								//czekaj na zwolnienie JP4
delay_ms(50);
while(1)
	{
	if(!jp4)								//jesli JP4=0, to odtworz
		{delay_ms(100);						//komunikat
		 isd25xx_play(i,wait);				//i czekaj na zwolnienie JP4
		 while(!jp4);
		 delay_ms(300);
		 if(++i>komunikaty) sleep();		//jesli odtworzono wszystkie
		}									//komunikaty, to uspij procesor
	}
sleep();
}
//************************************************************************//


//************************************************************************//
//   Procedura odczytuje wartosc napiecia i zapisuje ja w buforze cyfra                                                                     //
//   procedura jest sprawdzona dla zegara ukladu ICL7135=120kHz
//   dane sa utrzymywane przez czas 200 okresow zegara dla f=100kHz =2ms
//************************************************************************//
get_napiecie()
{

	disable_interrupts(global);
	while(!input(busy));				//czekaj na rozpoczecie pomiaru
	while(input(busy));					//czekaj na koniec biezacego pomiaru

	over=input(overrange);				//przepisz stan przekroczenia zakresu do over
	while(!input(d5));					//czekaj na cyfre nr5
	delay_us(500);						//czekaj na ustalenie sie danych
	cyfra[4]=data&0x0f;					//odczytaj cyfre 5, i zapisz ja do bufora

	while(!input(d4));					//czekaj na cyfre nr4
	delay_us(500);						//czekaj na ustalenie sie danych
	cyfra[3]=data&0x0f;					//odczytaj cyfre 4, i zapisz ja do bufora

	while(!input(d3));					//czekaj na cyfre nr3
	delay_us(500);						//czekaj na ustalenie sie danych
	cyfra[2]=data&0x0f;					//odczytaj cyfre 3, i zapisz ja do bufora

	while(!input(d2));					//czekaj na cyfre nr2
	delay_us(500);						//czekaj na ustalenie sie danych
	cyfra[1]=data&0x0f;					//odczytaj cyfre 2, i zapisz ja do bufora

	while(!input(d1));					//czekaj na cyfre nr1
	delay_us(500);						//czekaj na ustalenie sie danych
	cyfra[0]=data&0x0f;					//odczytaj cyfre 1, i zapisz ja do bufora

	minus=!input(pol);					//przepisz znak polaryzacji do bitu minus
	enable_interrupts(global);
}

//************************************************************************//


