     //   LIST
// P16F872.INC  Standard Header File, Version 1.00    Microchip Technology, Inc.
 //       NOLIST
#nolist

//;----- Register Files------------------------------------------------------

#byte		INDF                         =       0x0000
#byte		TMR0                         =       0x0001
#byte		PCL                          =       0x0002
#byte		STATUS                       =       0x0003
#byte		FSR                          =       0x0004
#byte		PORTA                        =       0x0005
#byte		PORTB                        =       0x0006
#byte		PORTC                        =       0x0007
#byte		PCLATH                       =       0x000A
#byte		INTCON                       =       0x000B
#byte		PIR1                         =       0x000C
#byte		PIR2                         =       0x000D
#byte		TMR1L                        =       0x000E
#byte		TMR1H                        =       0x000F
#byte		T1CON                        =       0x0010
#byte		TMR2                         =       0x0011
#byte		T2CON                        =       0x0012
#byte		SSPBUF                       =       0x0013
#byte		SSPCON                       =       0x0014
#byte		CCPR1L                       =       0x0015
#byte		CCPR1H                       =       0x0016
#byte		CCP1CON                      =       0x0017
#byte		ADRESH                       =       0x001E
#byte		ADCON0                       =       0x001F

#byte		OPTION_REG                   =       0x0081
#byte		TRISA                        =       0x0085
#byte		TRISB                        =       0x0086
#byte		TRISC                        =       0x0087
#byte		PIE1                         =       0x008C
#byte		PIE2                         =       0x008D
#byte		PCON                         =       0x008E
#byte		SSPCON2                      =       0x0091
#byte		PR2                          =       0x0092
#byte		SSPADD                       =       0x0093
#byte		SSPSTAT                      =       0x0094
#byte		ADRESL                       =       0x009E
#byte		ADCON1                       =       0x009F
#byte		EEDATA                       =       0x010C
#byte		EEADR                        =       0x010D
#byte		EEDATH                       =       0x010E
#byte		EEADRH                       =       0x010

#byte		EECON1                       =       0x018C
#byte		EECON2                       =       0x018D

// Porty

#bit  porta_0                      =     0x5.0
#bit  porta_1                      =     0x5.1
#bit  porta_2                      =     0x5.2
#bit  porta_3                      =     0x5.3
#bit  porta_4                      =     0x5.4
#bit  porta_5                      =     0x5.5
#bit  porta_6                      =     0x5.6
#bit  porta_7                      =     0x5.7
#bit  trisa_0                      =     0x85.0
#bit  trisa_1                      =     0x85.1
#bit  trisa_2                      =     0x85.2
#bit  trisa_3                      =     0x85.3
#bit  trisa_4                      =     0x85.4
#bit  trisa_5                      =     0x85.5
#bit  trisa_6                      =     0x85.6
#bit  trisa_7                      =     0x85.7

#bit  portb_0                      =     0x6.0
#bit  portb_1                      =     0x6.1
#bit  portb_2                      =     0x6.2
#bit  portb_3                      =     0x6.3
#bit  portb_4                      =     0x6.4
#bit  portb_5                      =     0x6.5
#bit  portb_6                      =     0x6.6
#bit  portb_7                      =     0x6.7
#bit  trisb_0                      =     0x86.0
#bit  trisb_1                      =     0x86.1
#bit  trisb_2                      =     0x86.2
#bit  trisb_3                      =     0x86.3
#bit  trisb_4                      =     0x86.4
#bit  trisb_5                      =     0x86.5
#bit  trisb_6                      =     0x86.6
#bit  trisb_7                      =     0x86.7

#bit  portc_0                      =     0x7.0
#bit  portc_1                      =     0x7.1
#bit  portc_2                      =     0x7.2
#bit  portc_3                      =     0x7.3
#bit  portc_4                      =     0x7.4
#bit  portc_5                      =     0x7.5
#bit  portc_6                      =     0x7.6
#bit  portc_7                      =     0x7.7
#bit  trisc_0                      =     0x87.0
#bit  trisc_1                      =     0x87.1
#bit  trisc_2                      =     0x87.2
#bit  trisc_3                      =     0x87.3
#bit  trisc_4                      =     0x87.4
#bit  trisc_5                      =     0x87.5
#bit  trisc_6                      =     0x87.6
#bit  trisc_7                      =     0x87.7


//----- STATUS Bits --------------------------------------------------------
//#byte STATUS                         =      0x03
#define  IRP                           0x03.7
#define  RP1                           0x03.6
#define  RP0                           0x03.5
#define  NOT_TO                        0x03.4
#define  NOT_PD                        0x03.3
#define  Z                             0x03.2
#define  DC                            0x03.1
#define  C                             0x03.0

//;----- INTCON Bits --------------------------------------------------------
//#byte  INTCON                        =  0X08B
#define  GIE                              0X008B.7
#define  PEIE                             0X008B.6
#define  T0IE                             0X008B.5
#define  INTE                             0X008B.4
#define  RBIE                             0X008B.3
#define  T0IF                             0X008B.2
#define  INTF                             0X008B.1
#define  RBIF                             0X008B.0

//;----- PIR1 Bits ----------------------------------------------------------
// Adres 0x00C
//bit 7 wolny
#define			ADIF                              0x006
#define			SSPIF                             0x003
#define			CCP1IF                            0x002
#define			TMR2IF                            0x001
#define			TMR1IF                            0x000

//;----- PIR2 Bits ----------------------------------------------------------
//adres	0x000D
#define			EEIF                              0x04
#define			BCLIF                             0x03

//;----- T1CON Bits ---------------------------------------------------------
// Timer1 0x0010
//bit 7 i 6 pusty
#define 		T1CKPS1                           0x05
#define 		T1CKPS0                           0x04
#define 		T1OSCEN                           0x03

#define 		NOT_T1SYNC                        0x02
#define 		T1INSYNC                          0x02    // Backward compatibility only

#define 		T1SYNC                            0x02
#define 		TMR1CS                            0x01
#define 		TMR1ON                            0x00

//;----- T2CON Bits ---------------------------------------------------------
//Timer2 0x0012
//bit 7 pusty
#define 		TOUTPS3                           0x06
#define 		TOUTPS2                           0x05
#define 		TOUTPS1                           0x04
#define 		TOUTPS0                           0x03
#define 		TMR2ON                            0x02
#define 		T2CKPS1                           0x01
#define 		T2CKPS0                           0x00

//;----- SSPCON Bits --------------------------------------------------------
// Adres 0x0014
#define		WCOL                              0x07
#define		SSPOV                             0x06
#define		SSPEN                             0x05
#define		CKP                               0x04
#define		SSPM3                             0x03
#define		SSPM2                             0x02
#define		SSPM1                             0x01
#define		SSPM0                             0x00

//;----- CCP1CON Bits -------------------------------------------------------
// adres 0x0017
//bit 7 i 6 pusty
#define		CCP1X                             0x05
#define		CCP1Y                             0x04
#define		CCP1M3                            0x03
#define		CCP1M2                            0x02
#define		CCP1M1                            0x01
#define		CCP1M0                            0x00

//;----- ADCON0 Bits --------------------------------------------------------
// adres0x001F
#define		ADCS1                             0x07
#define		ADCS0                             0x06
#define		CHS2                              0x05
#define		CHS1                              0x04
#define		CHS0                              0x03
#define		GO                                0x02

//NOT_DONE                     EQU     H'0002'
//GO_DONE                      EQU     H'0002'
// bit 1 pusty
#define		ADON                              0x00

//;----- OPTION_REG Bits -----------------------------------------------------
//Adres 0x0081 i 0x00181
#define			NOT_RBPU                          0x07
#define			INTEDG                            0x06
#define			T0CS                              0x05
#define			T0SE                              0x04
#define			PSA                               0x03
#define			PS2                               0x02
#define			PS1                               0x01
#define			PS0                               0x00

//;----- PIE1 Bits ----------------------------------------------------------
// Adres 0x008C
//bit 7 wolny
#define			ADIE                              0x6
//bit 5 i 4 wolne
#define			SSPIE                             0x3
#define			CCP1IE                            0x2
#define			TMR2IE                            0x1
#define			TMR1IE                            0x0

//;----- PIE2 Bits ----------------------------------------------------------
// adres 0x008D
#define			PIE2_EEIE                          0x04
#define			PIE2_BCLIE                             0x03

//;----- PCON Bits ----------------------------------------------------------
//Adres 0x008E
#define  			PNOT_POR                          0x01
#define  			NOT_BO                           0x00
#define  			NOT_BOR                          0x00

//;----- SSPCON2 Bits --------------------------------------------------------
//Adres 0x0091
#define 			GCEN                              0x07
#define 			ACKSTAT                           0x06
#define 			ACKDT                             0x05
#define 			ACKEN                             0x04
#define 			RCEN                              0x03
#define 			PEN                               0x02
#define 			RSEN                              0x01
#define 			SEN                               0x00

//;----- SSPSTAT Bits -------------------------------------------------------
// adres 0x0094
#define 		SMP                               0x07
#define 		CKE                               0x06
#define 		D                                 0x05
#define 		I2C_DATA                          0x05
#define 		NOT_A                             0x05
#define 		NOT_ADDRESS                       0x05
#define 		D_A                               0x05
#define 		DATA_ADDRESS                      0x05
#define 		P                                 0x04
#define 		I2C_STOP                          0x04
#define 		S                                 0x03
#define 		I2C_START                         0x03
#define 		R                                 0x02
#define 		I2C_READ                          0x02
#define 		NOT_W                             0x02
#define 		NOT_WRITE                         0x02
#define 		R_W                               0x02
#define 		READ_WRITE                        0x02
#define 		UA                                0x01
#define 		BF                                0x00

//;----- ADCON1 Bits --------------------------------------------------------
//Adres 0x009F
#define		ADFM                              0x07
#define		PCFG3                             0x03
#define		PCFG2                             0x02
#define		PCFG1                             0x01
#define		PCFG0                             0x00

//;----- EECON1 Bits --------------------------------------------------------
// adres 0x018C

#define	EEPGD                             0x07

//bity 6,5,4 puste
#define	WRERR                             0x03
#define	WREN                              0x02
#define	WR                                0x01
#define	RD                                0x00


#list
