
////////////////////////////////////////////////////////////////////////////
//  Name    :RS485_przekazniki.c                                          //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 		                                  //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-07-14                                                  //
//  Version : 1.0                                                         //
//  Notes   : Adres master='1', 				                          //
//          : predkosc 1200b                                              //
//																		  //
////////////////////////////////////////////////////////////////////////////
#include <16f84A.h>
#include <f84A.h>
#fuses XT,WDT,NOPROTECT,PUT				//bezpieczniki
#use delay(clock=4000000,RESTART_WDT)
#use rs232(baud=1200, xmit=PIN_A2, rcv=PIN_A0)  //konfiguracja transmisji
#id 1,2,0,2

#rom 0x2100={'1'}						//adres urzadzenia

#define esc	27							//znacznik poczatku transmisji danych(zerowanie)
#define enter 0x0D						//znacznik konca transmisji pakietu danych
#define master_adr	0					//adres zapisany w eeprom glownego modulu
#define enable pin_a1					//ustala kierunek transmisji =0 odbior, =1 nadawanie
#define jp1	pin_a3						//zworka do ustalenia adresu master
#define jp2	pin_a4						//zworka do przywrocenia podstawowego adresu master
#define DataPort	portb				//port wysylania danych
#define DataTris	trisb				//tris danych

int master;								//tu umieszczony jest adres glowny modulu, adres ten
										//jest odczytywany z eeprom i moze zostac zmieniony
										//przez zapis w eeprom, np. przez przeprogramowanie eeprom
GetRs485();								//odbiera dane z rs485
zmien_master();							//zmienia kod urzadzenia
/////////////////////////////////////////////////////////////////////////////
main()
{
if(bit_test(status,not_to))				//jesli normaly start to zeruj port
	{DataPort=0;						//na wyjscia danych wpisz 0

	}									//jesli reset WDT, to pozostaw porty jakie byly
setup_wdt(WDT_2304MS);
output_low(enable);						//MAX485 w trybie odnioru
DataTris=0;								//port danych jako wyjscie
if(!input(jp1)) zmien_master();			//jesli jp1 zwarte to idz do zmiany adresu urzadzenia
if(!input(jp2)) write_eeprom(master_adr,'1'); //jesli jp2=0, to przywroc poczatkowy adres
master=read_eeprom(master_adr);			//odczytuje adres master z eeprom

while(1)								//glowna petla
	{
	if(kbhit())							//jesli rozpoczeto wysylanie danych
		if(getc()==esc) GetRs485(); 	//jesli wyslano esc to idz do obslugi
	restart_wdt();						//reset wdt
 	}
}
/////////////////////////////////KONIEC   MAIN//////////////////////////////


//************************************************************************//
//  Zmienia adres, pod ktorym zglasza sie karta przekaznikow              //
//************************************************************************//
zmien_master()
{	int i;
	output_high(enable);
	printf("\rAktualny adres urzdzenia=%C",read_eeprom(master_adr));
	printf("\n\rAby zmieni ten adres nacinij klawisz nowego adresu");
	output_low(enable);
	while(1)							//glowna petla
		{

		if(kbhit())						//jesli rozpoczeto wysylanie danych
			{i=getc();					//to odbierz bajt
			write_eeprom(master_adr,i); //i zapisz go w eeprom
			output_high(enable);		//przelacz MAX485 w tryb nadawania
			printf("\rNowy adres urzdzenia=%C",read_eeprom(master_adr));
			output_low(enable);			//wyswietl nowy adres i przelacz
			sleep();					//w tryb odbioru
			}							//i przejdz w stan spoczynku
		restart_wdt();					//reset wdt
 	}
}
//***********************************************************************//



//***************************************************************************************//
//  Odbiera dane z RS485,analizuje i odpowienio steruje portem            				 //
//***************************************************************************************//
GetRS485()
{
int in,i,j,buf[11];							//deklaracja zmiennych
rs485_1:
i=0;in=0;
while(1)
  {restart_wdt();							//wdt reset
  if(kbhit()) 								//jesli wysylane sa znaki
	{in=getc();								//to odbierz znak i zapisz w in
	if(in==esc) goto rs485_1;				//jesli in=esc, to idz do poczatku procedury
	if(in!=enter)
	   {buf[i]=in;							//jesli in!=enter to zapisz do bufora
		if(buf[0]!=master) return;			//jesli zly adres master, to powrot
	   }
	else									//jesli nacisnieto enter
	   {
//jesli W to wpisuje to zapis do urzadzenia
	 if(buf[1]=='w'||buf[1]=='W') 		   //jesli ma byc zapis do urzadzenia
		{
		if(buf[2]=='a'||buf[2]=='A')	   //jesli wszystkie to przepisz wszystkie stany
		  {								   //z buf do DataPort
		   for(j=0;j<=7;j++)
		 	{if(buf[j+3]=='1') bit_set(dataPort,j);  //jesli bajt z buf=1 to ustaw dany bit portu
		 	 else if(buf[j+3]=='0') bit_clear(DataPort,j);//jesli =0 to zeruj odpowiedni bit portu
		 	}
		  }
		 else							   //jesli zmiana tylko jednego, to wpisz na podany numer
		   {
		   if(buf[3]=='1') bit_set(DataPort,buf[2]-'1'); //0 lub 1, w zaleznosci od podanej cyfry
		   else if(buf[3]=='0') bit_clear(DataPort,buf[2]-'1');
		    }
		 return;						   //i powrot

		 }
//jesli ma byc odczyt z urzadzenia
	 if(buf[1]=='r'||buf[1]=='R')		   //jesli ma odczytac stan
		{
		delay_us(100);					   //czekaj az nadajnik powroci do trybu odbioru
		output_high(enable);			   //przelacz MAX485 w tryb nadawania
		if(buf[2]=='a'||buf[2]=='A')	   //jesli ma byc odczyt wszystkich stanow
		  {for(j=0;j<=7;j++)
			{if(bit_test(DataPort,j)) putc('1');
			 else putc('0');
			}
		}
	 else									//jesli ma byc odczyt jednego stanu
		{
		if(bit_test(DataPort,buf[2]-'1')) putc('1');
		else putc('0');
		}
	    output_low(enable);					//przelacz MAX485 w tryb odbioru
	    return;								//powrot
	    }
	else return;  							//jesli inny to nic nie rob tylko powrot
	  }
	if(++i>11) return;						//jesli odebrano wiecej niz 11znakow to powrot
	 }
  	}
}
//***********************************************************************************************//


