
////////////////////////////////////////////////////////////////////////////
//  Name    : RC5_TX.h                                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 [AVT]                                    //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-12-06                                                  // 
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          : Procedury do transmisji RC5                                 // 
////////////////////////////////////////////////////////////////////////////
//Dziala dobrze dla kwarcu 20Mhz mozna zmienic na 4MHz, ale trzeba 
//zmienic wartosci dla stanu niskiego i wysokiego i zasieg jest mniejszy
#define led_ir gpio_1
#define tris_led_ir trisio_1

//************************************************************************//
// inicjalizacja portu diody                                              //		
//************************************************************************//
#define RC5_init() led_ir=0;\
		   tris_led_ir=0;	
//************************************************************************//



//************************************************************************//
//  wysyla logicze zero f=36kHz  kwarc 20MHz                              //		
//************************************************************************//
stan_0()
{int i;
	led_ir=0;
	for(i=32;i>0;i--)
	    {led_ir=1;
		delay_us(13);			//stan wysoki 13us
		delay_cycles(4);		//+800ns=13,8us
		led_ir=0;
		delay_us(13);			//stan niski 13us
		delay_cycles(1);		//+200ns=13,2us+3cykle=13,8us
		}						//13,2+(3*200)=13,8us,razem 2*13,8=27,6us=36,2khz
delay_us(875);					//875+13=888us
}
//************************************************************************//

//************************************************************************//
//  wysyla logiczna jedynke f=36kHz kwarc 20MHz                           //		
//************************************************************************//
stan_1()
{int i;
	led_ir=0;
	delay_us(888);
	
	for(i=32;i>0;i--)
	    {led_ir=1;
		delay_us(13);			
		delay_cycles(4);		//+800ns=13,8us
		led_ir=0;
		delay_us(13);			//stan niski 13us+3cykle przez licznik
		delay_cycles(1);		//+200ns+600ns=13,8us
		}						//razem 2*13,8=27,6us=36,2khz
}
//************************************************************************//

//************************************************************************//
//  Wysyla podana sekwencje w rc5                                         //		
//  toggle=1															  //
//  address 0-31														  //
//	command 0-63														  //
//************************************************************************//

RC5_send(int address, int command)
{	int ii;
	address|=0b11100000;
	command<<=2;
	for(ii=0;ii<=7;ii++)					//wysyla address+2bity startu =1, 
		{									//+ togglebit=1
		address<<=1;						//przesun w lewo o jeden
		if(bit_test(status,0)) stan_1();	//jesli c=1 to stan1	
		else stan_0();						//jesli 0 to stan0
		}
	for(ii=0;ii<=5;ii++)					//wysyla 5bitow command
		{
		command<<=1;						//przesun w lewo o jeden
		if(bit_test(status,0)) stan_1();	//jesli c=1 to stan1
		else stan_0();						//jesli 0 to stan0
		}

}
//************************************************************************//