 #include <16f76.h>
//typedef unsigned char uchar;
#include "pic16f76.h"
#include "srs.h"
#bit RS = porta.5
#bit EN = porta.4
void main()
{
int pom;
int volr,voll;
	set_tris_c(0);//all PORTC output
	set_tris_b(0xff);//all POTB input  
	port_b_pullups(true);//pullup PORTB on
	setup_adc_ports (no_analogs);//all PORTA digital
	delay_ms(40);
	inic_lcd();//interface 4 bit
	pozycja(4);//text 
	wysLCD("PROCESOR SRS");
	pozycja(0x46);
	wysLCD("AVT 2002");
	delay_ms(2000);
	wr_cmd(1);
	set_tris_c(0x18);// RC3,RC4 in RC5..RC7 out

	if(rd_eeprom(90)!=0xa6)//
	{
	for(pom=0;pom<=89;pom++)
	wr_eeprom(pom,0);
	wr_eeprom(90,0xa6);
	}
	sel_input(0x4c);//set input and att.

	inic_ust();//inicjalizacja ustawie pocztkowych z eeprom

	//petla glowna
	while(1){
	wr_cmd(1);	
	pozycja(0);
	wysLCD("volL -  dB");
	pozycja(0x40);
	wysLCD("volR -  dB");
	et_eff:
	voll=rd_eeprom(85);//vol L
	wys_dec(voll,6);	
	volr=rd_eeprom(86);//vol R 
	wys_dec(volr,0x46);
	et_in:pozycja(0x4a);
	wysLCD(" INPUT  ");
	pom=rd_eeprom(80);
	pom=pom+0x31;
	wr_data(pom);

	pozycja(10);
	wysLCD(" EFFECT ");
	wr_data(rd_eeprom(82)+0x31);

	et_kl:delay_ms(100);	
	while((portb&0x1f)==0x1f);//ait for press any key
	delay_ms(50);
	pom=portb&0x1f;
	if(pom==k_vold)//ciszej 
	{voll=rd_eeprom(85);//vol L 
	 volr=rd_eeprom(86);//vol R z tablicy efektu
	if(voll==79||volr==79)
	 goto et_kl;
	++voll;	
	
	wr_eeprom(85,voll);//write 
	wys_dec(voll,6);	
	++volr;
	wr_eeprom(86,volr);//write sets
	wys_dec(volr,0x46);
	wr_srs(sub_voll,voll|0x80);// srs kanal lewy (left)
	wr_srs(sub_volr,volr);// srs kanal prawy (right)
	goto et_kl;}	

	if(pom==k_volu)//glosniej
	{voll=rd_eeprom(85);//vol L 
	 volr=rd_eeprom(86);//vol R 
	if(voll==0||volr==0)
	 goto et_kl;
	--voll;
	 wr_eeprom(85,voll);//zapisanie ustawienia
	wys_dec(voll,6);	

	--volr;
	wr_eeprom(86,volr);//zapisanie ustawienia
	wys_dec(volr,0x46);
	wr_srs(sub_voll,voll|0x80);//zapisanie do srs kanal lewy
	wr_srs(sub_volr,volr);//zapisanie do srs kanal prawy
	goto et_kl;}	
	
	if(pom==k_in)
	{pom=rd_eeprom(80);
	 ++pom;
	 wr_eeprom(80,pom);
	 sel_input(0x4f);
	 pozycja(0x52);
	 goto et_in;}
	if(pom==k_fun)
	{sel_fun(rd_eeprom(81));
	 continue;}
	if(pom==k_acc)
	{
	 voll=rd_eeprom(82);//nr efektu
	 ++voll;
	 voll=voll&3; 
	 wr_eeprom(82,voll);
	 inic_ust();
	 goto et_eff;
	 }
	}
}
//inicjalizacja ustawien poczatkowych z eeprom zalenie od ustawionego numeru efektu
void inic_ust()
{
int temp,i,j;

	temp=adr_t_eff();
	j=0;
	for(i=temp;i<(temp+16);i++)
	{ust[j]=rd_eeprom(i);
	 ++j;}

	wr_srs(sub_surr,ust[1]);//surround ctrl
	wr_srs(sub_phres,ust[2]);
	
	wr_srs(sub_voll,rd_eeprom(85)|0x80);//voice L
	wr_srs(sub_volr,rd_eeprom(86));//voice R
	temp=ust[3];
	i=t_srs[temp];
	i=i|0x10;	
	wr_srs(sub_bass,i);//bass ctrl
	i=ust[5];
	temp=t_srs[i];//treble (skladanie middle & treble)
	temp=temp<<4;
	i=ust[4];
	temp=(temp|t_srs[i]);//or middle
	wr_srs(sub_mitr,temp);
	wr_srs(sub_voice,ust[8]);//voice canceller
	wr_srs(sub_srssp,ust[9]);//srs space
	wr_srs(sub_srsce,ust[10]);//srs center
	}

void sel_fun(int nr_fun)
{
int kod;
	
	while(1){
	pozycja(0x40);
	wysLCD("[esc]exit   [+-]sel ");
	pozycja(15);
	wysLCD("[acc]  ");
	disp_fun(nr_fun);//wyswietlenie nazwy funkcji			
	kod=klawiatura();
	if(kod==k_volu)
	{++nr_fun;
	 if(nr_fun==6)
	 nr_fun=0;
	 continue;}
	if(kod==k_vold)
	{--nr_fun;
	 if(nr_fun==0xff)
	 nr_fun=5;
	 continue;}
	if(kod==k_in)
	return;
	if(kod==k_acc)
	{wr_eeprom(81,nr_fun);
	wyk_funkcji(nr_fun);}
	}
}
void wyk_funkcji(int nr_fun)
{
int pom;
	if(nr_fun==0)
	wf_surr_ef();//wykonanie funkcji surround effect
	if(nr_fun==1)
	wf_tone_ctrl();
	if(nr_fun==2)
	{wf_balance_ctrl();//funkcja regulacji balansu
	 wf_record_ctrl(); 
	 wf_inp_att();}//regulacja tumienia wejcia	      
	if(nr_fun==3)
	wf_nr_effect();//wykonanie funkcjii wyboru efektu
	if(nr_fun==4)
	wf_srs_ctrl();//wykonanie funkcji ustawienia SRS
	if(nr_fun==5)
	wf_voice_can();//wykonanie funkcji voice canceller
}
void disp_fun(int nr_fun)
{		 
	pozycja(0);
	if(nr_fun==0)
	{wysLCD("SURROUND       ");
	 return;}
	if(nr_fun==1)
	{wysLCD("TONE CONTROL   ");
	 return;}
	if(nr_fun==2)
	{wysLCD("VOLUME CONTROL ");
	 return;}
	if(nr_fun==3)
	{wysLCD("EFFECT         ");
	 return;}
	if(nr_fun==4)
	{wysLCD("SRS CONTROL    ");
	 return;}
	if(nr_fun==5)
	{wysLCD("VOICE CANCELL. ");
	 return;}
	
}
void wf_voice_can()
{
int pom,kod,var;
	pozycja(0);
	wysLCD("VOICE CANC & REC OUT");
	pozycja(0x40);
	wysLCD("       Y[acc] N[esc]");
	pom=rd_eeprom(adr_t_eff()+8);//voice canceller
	while(1){
	pozycja(0x40);
	if((pom&1)==0)
	wysLCD("OFF");
	else
	wysLCD("ON ");
	kod=klawiatura();
	if(kod==k_acc)
	 break;
	if(kod==k_in)
	 {if((pom&1)==1)
	 pom=pom&0xfe;//zerowanie b0
	 else
	 pom=pom|1;}//ustawienie b0

	 pom=pom|0x86;//b1=1,b2=1,b7=1
	 wr_srs(sub_voice,pom);//zapisanie do procesora
	}
	
	pozycja(0);
	wysLCD("REC OUT L           ");
	pozycja(0x40);
	wysLCD("       Y[acc] N[esc]");
	var=pom;
	pom=pom&0xe7;//wyciecie b4 i b3
	var=var>>3;
	var=var&3;
	while(1){
	wys_var(var);
	kod=klawiatura();	
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++var;
	var=var&3;}
	pom=pom&0xe7;
	var=var<<3;
	pom=pom|var;
	wr_srs(sub_voice,pom);//zapisanie do procesora
	var=var>>3;
	}

	pozycja(0);
	wysLCD("REC OUT R           ");
	var=pom;
	var=var>>5;
	var=var&3;
	while(1){
	wys_var(var);
	kod=klawiatura();	
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++var;
	 var=var&3;}
	
	var=var<<5;
	pom=pom&0x9f;
	pom=pom|var;
	wr_srs(sub_voice,pom);//zapisanie do procesora
	var=var>>5;
	}
	wr_eeprom(adr_t_eff()+8,pom);//zapisanie do tablicy efektw

}
//funkcja ustawienia parametrow SRS
void wf_srs_ctrl()
{
int pom,kod,var;
	
	pom=rd_eeprom(adr_t_eff()+9);//srs space ctrl
	pozycja(0);
	wysLCD("SRS SPACE ATT.      ");
	pozycja(0x40);
	wysLCD("-  db[+-]sel[acc]acc");
	while(1){
	wys_dec(pom,0x41);
	delay_ms(150);	
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_volu)
	{--pom;
	 if(pom==0xff)
	 pom=0;}
	if(kod==k_vold)
	{++pom;
	 if(pom==33)
	 pom=32;}
	if(kod==k_acc)
	break;
	wr_srs(sub_srssp,pom);//zapisanie do procesora
	}
	wr_eeprom(adr_t_eff()+9,pom);

	pom=rd_eeprom(adr_t_eff()+10);//srs space ctrl
	var=pom;
	var=var&0x3f;
	pozycja(0);
	wysLCD("SRS CENTER ATT.      ");
	pozycja(0x40);
	wysLCD("-  db[+-]sel[acc]acc");
	while(1){
	wys_dec(var,0x41);
	delay_ms(150);	
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_volu)
	{--var;
	 if(var==0xff)
	 var=0;}
	if(kod==k_vold)
	{++var;
	 if(var==33)
	 var=32;}
	if(kod==k_acc)
	break;
	
	pom=pom&0xc0;
	pom=pom|var;
	wr_srs(sub_srsce,pom);//zapisanie do procesora
	}
	wr_eeprom(adr_t_eff()+10,pom);
	
	pozycja(0);
	wysLCD("SRS INPUT SURROUND  ");
	pozycja(0x40);
	wysLCD("     Y[acc]N[esc]   ");
	while(1){
	pozycja(0x40);
	if((pom&0x40)==0x40)
	 wysLCD("YES");
	else
	 wysLCD("NO ");
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{if((pom&0x40)==0x40)
	 pom=pom&0xbf;//no signal surround
	else
	 pom=pom|0x40;}
	wr_srs(sub_srsce,pom);//zapisanie do procesora
	}
	wr_eeprom(adr_t_eff()+10,pom);	
	
	pozycja(0);
	wysLCD("SRS SWITCH           ");
	pozycja(0x40);
	while(1){
	pozycja(0x40);
	if((pom&0x80)==0x80)
	 wysLCD("OFF");
	else
	 wysLCD("ON ");
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{if((pom&0x80)==0x80)
	 pom=pom&0x7f;//no signal surround
	else
	 pom=pom|0x80;}
	wr_srs(sub_srsce,pom);//zapisanie do procesora
	}
	wr_eeprom(adr_t_eff()+10,pom);	
}
void wys_var(int var)
{
	if(var==0)
	{pozycja(10);
	 wysLCD("3BAND");
	 pozycja(0x40);
	 wysLCD("VAR1");}
	if(var==1)
	{pozycja(10);
	 wysLCD("SURR ");
	 pozycja(0x40);
	 wysLCD("VAR2");}
	if(var==2)
	{pozycja(10);
	 wysLCD("REAR ");
	 pozycja(0x40);
	 wysLCD("VAR3");}
	if(var==3)
	{pozycja(10);
	 wysLCD("FIX  ");
	 pozycja(0x40);
	 wysLCD("FIX ");}
}
short bit_l_p,vol_rec;
void wf_record_ctrl()
{int vol;
	vol_rec=0;//zapisanie record
	pozycja(0);
	wysLCD("LEFT  REC -  dB     ");
	pozycja(0x40);
	wysLCD("[+-]sel. [acc]accept");
	bit_l_p=0;
	vol=set_vol(rd_eeprom(78));//vol L 
	wr_eeprom(78,vol);//zapisanie ustawienia
	pozycja(0);
	wysLCD("RIGHT REC -  dB     ");
	bit_l_p=1;
	vol=set_vol(rd_eeprom(79));//vol R 
	wr_eeprom(79,vol);//zapisanie ustawienia
}
//regulacja balansu
void wf_balance_ctrl()
{
int vol;
	vol_rec=1;//zapisanie volume
	pozycja(0);
	wysLCD("LEFT  VOL -  dB     ");
	pozycja(0x40);
	wysLCD("[+-]sel. [acc]accept");
	bit_l_p=0;
	vol=set_vol(rd_eeprom(85));//vol L 
	wr_eeprom(85,vol);//zapisanie ustawienia
	pozycja(0);
	wysLCD("RIGHT VOL -  dB     ");
	bit_l_p=1;
	vol=set_vol(rd_eeprom(86));//vol R 
	wr_eeprom(86,vol);//zapisanie ustawienia
}
int set_vol(int vol)
{
int kod;
	while(1){	
	wys_dec(vol,11);//wyswietlenie wartosci glosnosci
	delay_ms(130);	
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_vold)
	{++vol;
	 if(vol==80)
	 vol=79;
	}
	if(kod==k_volu)
	{--vol;
	 if(vol==0xff)
	 vol=0;}
	if(kod==k_acc)
	 break;	
	if(bit_l_p==0)
	{if(vol_rec==1)
	 wr_srs(sub_voll,vol|0x80);//zapisanie do srs volume kanal lewy
	  else
	 wr_srs(sub_recl,vol|0x80);}//zapisanie do srs record kanal lewy
	else
	{if(vol_rec==1)
	 wr_srs(sub_volr,vol);//zapisanie do srs kanal prawy
	 else 
	 wr_srs(sub_recr,vol);}//zapisanie do srs record kanal prawy
	}
	klawiatura();
	return(vol);
}
//ustawienie aktywnego wejscia
void sel_input(int poz)
{	
int t_inp;
	t_inp=rd_eeprom(80);//numer aktywnego wejscia
	 if(t_inp==3)
	 t_inp=0;
	 wr_srs(sub_inp,0x7f);// max tlumienia wejscia	 
	 delay_ms(50); 
	 if(t_inp==0)
	 {output_c(0x20);
	  wr_srs(sub_inp,rd_eeprom(87));}//wpisanie tumienia przypisanego wejciu
	 if(t_inp==1)
	 {output_c(0x40);
	  wr_srs(sub_inp,rd_eeprom(88));}
	 if(t_inp==2)
	 {output_c(0x80);
	  wr_srs(sub_inp,rd_eeprom(89));}
	wr_eeprom(80,t_inp);	
}
//ustawienie tumienia wejscia
void wf_inp_att()
{
int inp,pom,kod,att;

	inp=rd_eeprom(80);//numer aktywnego wejcia
	if(inp==0)
	att=rd_eeprom(87);
	if(inp==1)
	att=rd_eeprom(88);
	if(inp==2)
	att=rd_eeprom(89);
	pozycja(0);
	wysLCD("INPUT   ATTENUATION ");
	pozycja(6);
	wr_data(inp+0x31);//wyswietlenie numeru wejcia
	pozycja(0x40);
	wysLCD("-  . dB[+-]selY[acc]");
	while(1){
	pom=att;
	pom=pom/2;
	wys_dec(pom,0x41);
	pozycja(0x44);
	if(pom*2==att)
	wr_data(0x30);
	else
	wr_data(0x35);
	delay_ms(130);	
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_volu)
	{--att;
	 if(att==0xff)
	 att=0;}
	if(kod==k_vold)
	{++att;
	 if(att==0x40)
	 att=0x3f;}
	if(kod==k_acc)
	break;
	wr_srs(sub_inp,(att|0x40));//wpisanie tlumienia wejscia
	}

	if(inp==0)
	wr_eeprom(87,att);
	if(inp==1)
	wr_eeprom(88,att);
	if(inp==2)
	wr_eeprom(89,att);
	klawiatura();

}
//regulacja barwy
void wf_tone_ctrl()
{
int tone,kod;

	pozycja(0x40);
	wysLCD("[+-]sel. [acc]accept");
	tone=rd_eeprom(83);//numer wybranej ostatnio funkcji 	
	while(1){
	pozycja(0);
	if(tone==0)
	wysLCD("BASS     [esc]escape");
	if(tone==1)
	wysLCD("MIDDLE   [esc]escape");
	if(tone==2)
	wysLCD("TREBLE   [esc]escape");
	kod=klawiatura();
	if(kod==k_volu||kod==k_vold)
	{++tone;
	 if(tone==3)
	 tone=0;
	 continue;}
	if(kod==k_acc)
	{wr_eeprom(83,tone);
	reg_tony(tone);
	continue;}
	if(kod==k_in)
	break;
	}
}
void reg_tony(int r_tonow)
{
int poz,tone,kod,temp,tsrs;
	if(r_tonow==0)
	poz=rd_eeprom(adr_t_eff()+3);//adres basow w tablicy efektu
	if(r_tonow==1)
	poz=rd_eeprom(adr_t_eff()+4);//adres srednich w tablicy efektu
	if(r_tonow==2)
	poz=rd_eeprom(adr_t_eff()+5);//adres wysokich w tablicy efektu
	
	poz=poz&0x0f;
	pozycja(0);
	if(r_tonow==0)
	wysLCD("BASS      dB         ");
	if(r_tonow==1)
	wysLCD("MIDDLE    dB         ");
	if(r_tonow==2)
	wysLCD("TREBLE    dB         ");

	pozycja(0x40);
	wysLCD("[+-]sel. [acc]accept ");
	while(1){
	tone=t_wys[poz];
	pozycja(7);
	if((tone&0x80)==0x80)
	wr_data('-');
	else
	wr_data('+');
	tone=tone&0x0f;
	wys_dec(tone,8);//wyswietlenie wartosci tonow
	delay_ms(240);
	
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_volu)
	{++poz;
	 if(poz==15)
	 poz=14;}
	if(kod==k_vold)
	{--poz;
	 if(poz==0xff)
	 poz=0;}
	if(kod==k_acc)
	 break;	
	tsrs=t_srs[poz];
	if(r_tonow==0)//zapisanie wyregulowanych wartosci
	wr_srs(sub_bass,(tsrs|0x10));//bass ctrl

	if(r_tonow==1)//srednie
	{kod=rd_eeprom(adr_t_eff()+5);//treble (skladanie middle & treble)
	 temp=t_srs[kod];//rzeczywista warto treble
	 temp=temp<<4;
	 temp=(temp|tsrs);//or middle
	 wr_srs(sub_mitr,temp);}

	if(r_tonow==2)//wysokie
	{tsrs=tsrs<<4;//treble (skladanie middle & treble)	 
	 temp=rd_eeprom(adr_t_eff()+4);
	 kod=t_srs[temp];//rzeczywaista warto middle
	 tsrs=(tsrs|kod);//or middle
	 wr_srs(sub_mitr,tsrs);}
	}
	klawiatura();
	if(r_tonow==0)//zapisanie wyregulowanych wartosci
	wr_eeprom(adr_t_eff()+3,poz);//basy
	if(r_tonow==1)
	wr_eeprom(adr_t_eff()+4,poz);//srednie
	if(r_tonow==2)
	wr_eeprom(adr_t_eff()+5,poz);//wysokie
}
//ustawienie numeru efektu
void wf_nr_effect()
{
int kod,eff;
	pozycja(0);
	wysLCD("SELECT EFFECT       ");
	pozycja(0x40);
	wysLCD("< > [+-] Y[acc]     ");
	eff=rd_eeprom(82);//nr efektu
	while(1){
	pozycja(0x41);
	wr_data(eff+0x31);//ascii nr efektu
	kod=klawiatura();
	if(kod==k_volu)
	++eff;
	if(kod==k_vold)
	--eff;
	eff=eff&3;
	if(kod==k_acc)
	break;
	wr_eeprom(82,eff);
	inic_ust();
	//eff_load();
	}
	wr_eeprom(82,eff);
}
int adr_t_eff()
{
int efekt;
	efekt=rd_eeprom(82);//numer efektu
	efekt=efekt*16;
	return(efekt);
}
#separate
void wf_surr_ef()
{
int kod,surr;
int t_surr,surr_ef;

	surr_ef=rd_eeprom(adr_t_eff()+1);//adres w tablicy efektu
	surr=surr_ef&3;
	wr_cmd(1);//wyczysc ekran
	pozycja(0);
	wysLCD("   SURROUND MODE     ");
	
	while(1){
	wys_surr_mod(surr);
	kod=klawiatura();
	if(kod==k_acc)
	{wys_surr_mod_u(surr);
	 break;}	 
	if(kod==k_in)
	{++surr;
	 surr=surr&3;}
	surr_ef=surr_ef&0xfc;
	surr_ef=surr_ef|surr;//nowa warto standard surround selection
	wr_srs(sub_surr,surr_ef);//surround ctrl do procesora
	}

	pozycja(0);//ustawianie SURRound out
	wysLCD("SURR.OUT ");
	t_surr=surr_ef&4;
	pozycja(0x46);	
	wysLCD(" Y[acc] N[esc]");
	while(1){
	pozycja(0x40);	
	if(t_surr==0)
	wysLCD("VAR   ");  
	else
	wysLCD("FIX   ");	
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{if(t_surr==4)
	t_surr=0;
	else 
	t_surr=4;}
	surr_ef=surr_ef&0xfb;//wycicie out
	surr_ef=surr_ef|t_surr;
	wr_srs(sub_surr,surr_ef);//surround ctrl do procesora
	}
	pozycja(0);
	if(t_surr==0)
	wysLCD("(VAR)   ");  
	else
	wysLCD("(FIX)   ");

	surr=surr_ef;
	surr=surr&7;//wycicie effect controll	
	
	pozycja(0x40);
	wysLCD("EFFECT -  dB [+][-]  )");
	while(1){
	surr_ef=surr_ef>>3;//wartosc effect control
	wys_dec(surr_ef+6,0x48);
	delay_ms(240);
	while((portb&0x1f)==0x1f);//czekaj na przycisniecie klawisza
	delay_ms(50);
	kod=portb&0x1f;
	if(kod==k_vold)
	{++surr_ef;
	if(surr_ef==16)
	 surr_ef=15;}
	if(kod==k_volu)
	{--surr_ef;
	 if(surr_ef==0xff)
	 surr_ef=0;}
	if(kod==k_acc)
	{surr_ef=surr_ef<<3;
	surr_ef=surr_ef|surr;//dopisanie surround mode
	break;}
	surr_ef=surr_ef<<3;
	surr_ef=surr_ef|surr;//dopisanie surround mode
	wr_srs(sub_surr,surr_ef);//surround ctrl do procesora
	}
	klawiatura();
	delay_ms(100);
	
	wr_eeprom(adr_t_eff()+1,surr_ef);//zapisanie surr ctrl do eeprom
	
	surr_ef=rd_eeprom(adr_t_eff()+2);//phase resistor z tablicy efektw
	pozycja(0);
	wysLCD("RES. PHASE SHIFT 1  ");
	pozycja(0x40);
	wysLCD("  k   Y[acc] N[esc] ");
	pozycja(0x43);
	wr_data(0xf4); 

	surr=surr_ef;
	surr=surr&3;
	while(1){ 
	wys_dec(phase_res1[surr],0x40);
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++surr;
	 surr=surr&3;}
	surr_ef=surr_ef&0xfc;
	surr_ef=surr_ef|surr;
	wr_srs(sub_phres,surr_ef);//zapisanie do procesora
	}
	pozycja(17);
	wr_data(0x32);	
	surr=surr_ef;

	while(1){ 
	surr=surr>>2;
	surr=surr&3;
	wys_dec(phase_res2[surr],0x40);
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++surr;
	 surr=surr&3;}
	
	surr=surr<<2;
	surr_ef=surr_ef&0xf3;
	surr_ef=surr_ef|surr;
	wr_srs(sub_phres,surr_ef);//zapisanie do procesora
	}

	pozycja(17);
	wr_data(0x33);	
	surr=surr_ef;
	while(1){ 
	surr=surr>>4;
	surr=surr&3;
	wys_dec(phase_res1[surr],0x40);
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++surr;
	 surr=surr&3;}
	
	surr=surr<<4;
	surr_ef=surr_ef&0xcf;
	surr_ef=surr_ef|surr;
	wr_srs(sub_phres,surr_ef);//zapisanie do procesora
	}
	pozycja(17);
	wr_data(0x34);	
	surr=surr_ef;
	while(1){ 
	surr=surr>>6;
	surr=surr&3;
	wys_dec(phase_res1[surr],0x40);
	kod=klawiatura();
	if(kod==k_acc)
	break;
	if(kod==k_in)
	{++surr;
	 surr=surr&3;}
	
	surr=surr<<6;
	surr_ef=surr_ef&0x3f;
	surr_ef=surr_ef|surr;
	wr_srs(sub_phres,surr_ef);//zapisanie do procesora
	}
	wr_eeprom(adr_t_eff()+2,surr_ef);

}
void wys_surr_mod(int surr)
{
	pozycja(0x40);	
	if(surr==0)
	wysLCD("<SIM.> ");
	if(surr==1)
	wysLCD("<MUSIC>");	
	if(surr==2)
	wysLCD("<OFF>  ");
	if(surr==3)
	wysLCD("<MOVIE>");
	wysLCD(" Y[acc]N[esc]");
}
void wys_surr_mod_u(int surr)
{
	pozycja(9);
	if(surr==0)//ustawienie SIMULATED	
	 wysLCD("(SIMULATED)");
	if(surr==1)
	 wysLCD("    (MUSIC)");
	if(surr==2)//ustawienie SIMULATED
	 wysLCD("      (OFF)");
	if(surr==3)//ustawienie SIMULATED
	 wysLCD("    (MOVIE)");
}

//wyswietlenie nazwy funkcji podstawowej

void wys_hex(int wartosc)
{
int pom;
	pozycja(0x4f);
	pom=wartosc;
	pom=pom>>4;
	if(pom<10)
	pom=pom+0x30;
	else 
	pom=pom+0x37;
	wr_data(pom);
	pom=wartosc;
	pom=pom&0x0f;
	if(pom<10)
	pom=pom+0x30;
	else 
	pom=pom+0x37;
	wr_data(pom);
}

//wyswietlenie wartosci w postaci 2cyfrowej liczby hex
void wys_dec(char wartosc,char poz)
{
char ldzies,ljedn;
	pozycja(poz); 
	ldzies=wartosc/10;
	wr_data(ldzies+0x30);
	ldzies=ldzies*10;
	wartosc=wartosc-ldzies;	
	wr_data(wartosc+0x30);
	
}

void wr_srs(int subadres,int data)
{
	i2c_start();
	i2c_write(0x80);
	i2c_write(subadres);
	i2c_write(data);
	i2c_stop();
	delay_ms(1);
}
//zapisanie danej do 24c04
void wr_eeprom(int adres,int dana)
{
	i2c_start();	
	i2c_write(0xa0);
	i2c_write(adres);
	i2c_write(dana);
	i2c_stop();
	delay_ms(11);
	
}
//odczytanie danej z 24c04
int rd_eeprom(int adres)
{
	i2c_start();
	i2c_write(0xa0);
	i2c_write(adres);
	i2c_start();
	i2c_write(0xa1);//zmiana kierunku
	return(i2c_read(0));
}

//obsluga klawiatury
#separate
int klawiatura()
{
int port;
	while((portb&0x1f)==0x1f);//czekaj na wcisniecie	
	delay_ms(80);//80msek na drgania stykow	
	port=portb&0x1f;
	while((portb&0x1f)!=0x1f);//czekaj na puszczenie
	delay_ms(40);
	return(port);

}
	
//ustawienie pozycji na wywietlaczu lcd
#separate
void pozycja(int poz)
{	
  wr_cmd(poz|0x80);//zapisz adres	
}
//wyswietlenie napisu od pozycji 
#separate
void wysLCD(char napis)
{	
	wr_data(napis);
}
void inic_lcd()
{
	delay_ms(50);//opoznienie 50msek
	RS=0;//rejestr IR
	EN=1;
	dane_lcd(3);//ustaw 3 na RA0...RA3
	EN=0;
	delay_ms(6);
	EN=1;
	delay_cycles(5);
	EN=0;
	delay_us(150);
	EN=1;
	delay_cycles(5);
	EN=0;
	delay_us(150);
	
	wr_cmd(0x28);//function set
	wr_cmd(8);//display off
	wr_cmd(1);//display clear
	wr_cmd(6);//entry mod
	wr_cmd(0x0c);//display on
}
void wr_cmd(int cmd)
{
	RS=0;
	wr_lcd(cmd);
}
void wr_data(int data)
{
	RS=1;
	wr_lcd(data);
}
void wr_lcd(int dana)
{
int TMP;
	TMP=dana;
	EN=1;
	swap(TMP);	
	dane_lcd(TMP);//bardziej znaczacy polbajt
	EN=0;
	delay_cycles(2);//wpisanie do modulu
	EN=1;
	swap(TMP);
	dane_lcd(TMP);//mniej znaczacy polbajt
	EN=0;
	if(RS==1)
	delay_us(200);
	else
	delay_ms(3);
}

void dane_lcd(int dana)
{
	dana=dana&0x0f;
	porta=porta&0xf0;
	porta=porta|dana;
}

